/* archive-writer.c generated by valac 0.26.1, the Vala compiler
 * generated from archive-writer.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/
/* A non-threadsafe wrapper for libarchives write archive*/

#include <glib.h>
#include <glib-object.h>
#include <archive.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <libcommon.h>
#include <archive_entry.h>
#include <glib/gstdio.h>
#include <stdio.h>
#include <sys/stat.h>


#define BOXES_TYPE_ARCHIVE_WRITER (boxes_archive_writer_get_type ())
#define BOXES_ARCHIVE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_ARCHIVE_WRITER, BoxesArchiveWriter))
#define BOXES_ARCHIVE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_ARCHIVE_WRITER, BoxesArchiveWriterClass))
#define BOXES_IS_ARCHIVE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_ARCHIVE_WRITER))
#define BOXES_IS_ARCHIVE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_ARCHIVE_WRITER))
#define BOXES_ARCHIVE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_ARCHIVE_WRITER, BoxesArchiveWriterClass))

typedef struct _BoxesArchiveWriter BoxesArchiveWriter;
typedef struct _BoxesArchiveWriterClass BoxesArchiveWriterClass;
typedef struct _BoxesArchiveWriterPrivate BoxesArchiveWriterPrivate;
#define _archive_write_finish0(var) ((var == NULL) ? NULL : (var = (archive_write_finish (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block11Data Block11Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define BOXES_TYPE_ARCHIVE_READER (boxes_archive_reader_get_type ())
#define BOXES_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReader))
#define BOXES_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderClass))
#define BOXES_IS_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_ARCHIVE_READER))
#define BOXES_IS_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_ARCHIVE_READER))
#define BOXES_ARCHIVE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderClass))

typedef struct _BoxesArchiveReader BoxesArchiveReader;
typedef struct _BoxesArchiveReaderClass BoxesArchiveReaderClass;
typedef struct _Block12Data Block12Data;
typedef struct _BoxesArchiveReaderPrivate BoxesArchiveReaderPrivate;
typedef struct _Block13Data Block13Data;
typedef struct _Block14Data Block14Data;
#define _archive_entry_free0(var) ((var == NULL) ? NULL : (var = (archive_entry_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _Block15Data Block15Data;

struct _BoxesArchiveWriter {
	GObject parent_instance;
	BoxesArchiveWriterPrivate * priv;
	struct archive* archive;
};

struct _BoxesArchiveWriterClass {
	GObjectClass parent_class;
};

struct _BoxesArchiveWriterPrivate {
	GList* filters;
	int format;
};

struct _Block11Data {
	int _ref_count_;
	BoxesArchiveWriter* self;
	gchar* filename;
};

struct _Block12Data {
	int _ref_count_;
	BoxesArchiveWriter* self;
	gchar* filename;
};

struct _BoxesArchiveReader {
	GObject parent_instance;
	BoxesArchiveReaderPrivate * priv;
	struct archive* archive;
};

struct _BoxesArchiveReaderClass {
	GObjectClass parent_class;
};

struct _Block13Data {
	int _ref_count_;
	BoxesArchiveWriter* self;
	struct archive_entry* iterator;
};

struct _Block14Data {
	int _ref_count_;
	BoxesArchiveWriter* self;
	struct archive_entry* entry;
};

struct _Block15Data {
	int _ref_count_;
	BoxesArchiveWriter* self;
	int filter;
};


static gpointer boxes_archive_writer_parent_class = NULL;

GType boxes_archive_writer_get_type (void) G_GNUC_CONST;
#define BOXES_ARCHIVE_WRITER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BOXES_TYPE_ARCHIVE_WRITER, BoxesArchiveWriterPrivate))
enum  {
	BOXES_ARCHIVE_WRITER_DUMMY_PROPERTY
};
BoxesArchiveWriter* boxes_archive_writer_new (const gchar* filename, int format, GList* filters, GError** error);
BoxesArchiveWriter* boxes_archive_writer_construct (GType object_type, const gchar* filename, int format, GList* filters, GError** error);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void boxes_archive_writer_prepare_archive (BoxesArchiveWriter* self, GError** error);
static int __lambda66_ (Block11Data* _data11_);
static int ___lambda66__boxes_libarchive_function (gpointer self);
GType boxes_archive_reader_get_type (void) G_GNUC_CONST;
BoxesArchiveWriter* boxes_archive_writer_new_from_archive_reader (BoxesArchiveReader* archive_reader, const gchar* filename, gboolean import_contents, GError** error);
BoxesArchiveWriter* boxes_archive_writer_construct_from_archive_reader (GType object_type, BoxesArchiveReader* archive_reader, const gchar* filename, gboolean import_contents, GError** error);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void boxes_archive_writer_copy_filters_from_read_archive (BoxesArchiveWriter* self, struct archive* read_archive);
static int __lambda67_ (Block12Data* _data12_);
static int ___lambda67__boxes_libarchive_function (gpointer self);
void boxes_archive_reader_reset (BoxesArchiveReader* self, GError** error);
void boxes_archive_writer_import_read_archive (BoxesArchiveWriter* self, BoxesArchiveReader* archive_reader, gchar** omit_files, int omit_files_length1, gboolean omit_hardlinked_files, GError** error);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static int ___lambda68_ (Block13Data* _data13_);
static int ____lambda68__boxes_libarchive_function (gpointer self);
static void boxes_archive_writer_insert_data (BoxesArchiveWriter* self, void* data, gint64 len, GError** error);
void boxes_archive_writer_insert_files (BoxesArchiveWriter* self, gchar** src_list, int src_list_length1, gchar** dest_list, int dest_list_length1, GError** error);
void boxes_archive_writer_insert_file (BoxesArchiveWriter* self, const gchar* src, const gchar* dest, GError** error);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static struct archive_entry* boxes_archive_writer_get_entry_for_file (BoxesArchiveWriter* self, const gchar* filename, const gchar* dest_name);
static int __lambda69_ (Block14Data* _data14_);
static int ___lambda69__boxes_libarchive_function (gpointer self);
static int __lambda64_ (BoxesArchiveWriter* self);
static int ___lambda64__boxes_libarchive_function (gpointer self);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static int _____lambda65_ (Block15Data* _data15_);
static int ______lambda65__boxes_libarchive_function (gpointer self);
static void boxes_archive_writer_finalize (GObject* obj);


static Block11Data* block11_data_ref (Block11Data* _data11_) {
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}


static void block11_data_unref (void * _userdata_) {
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		BoxesArchiveWriter* self;
		self = _data11_->self;
		_g_free0 (_data11_->filename);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}


static int __lambda66_ (Block11Data* _data11_) {
	BoxesArchiveWriter* self;
	int result = 0;
	struct archive* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	int _tmp2_ = 0;
	self = _data11_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data11_->filename;
	_tmp2_ = archive_write_open_filename (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static int ___lambda66__boxes_libarchive_function (gpointer self) {
	int result;
	result = __lambda66_ (self);
	return result;
}


BoxesArchiveWriter* boxes_archive_writer_construct (GType object_type, const gchar* filename, int format, GList* filters, GError** error) {
	BoxesArchiveWriter * self = NULL;
	Block11Data* _data11_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	struct archive* _tmp2_ = NULL;
	int _tmp3_ = 0;
	GList* _tmp4_ = NULL;
	GList* _tmp5_ = NULL;
	struct archive* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_tmp0_ = filename;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_data11_->filename);
	_data11_->filename = _tmp1_;
	self = (BoxesArchiveWriter*) g_object_new (object_type, NULL);
	_data11_->self = g_object_ref (self);
	_tmp2_ = archive_write_new ();
	_archive_write_finish0 (self->archive);
	self->archive = _tmp2_;
	_tmp3_ = format;
	self->priv->format = _tmp3_;
	_tmp4_ = filters;
	_tmp5_ = g_list_copy (_tmp4_);
	_g_list_free0 (self->priv->filters);
	self->priv->filters = _tmp5_;
	boxes_archive_writer_prepare_archive (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block11_data_unref (_data11_);
			_data11_ = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			block11_data_unref (_data11_);
			_data11_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = self->archive;
	boxes_execute_libarchive_function (_tmp6_, ___lambda66__boxes_libarchive_function, _data11_, (guint) 1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block11_data_unref (_data11_);
			_data11_ = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			block11_data_unref (_data11_);
			_data11_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	block11_data_unref (_data11_);
	_data11_ = NULL;
	return self;
}


BoxesArchiveWriter* boxes_archive_writer_new (const gchar* filename, int format, GList* filters, GError** error) {
	return boxes_archive_writer_construct (BOXES_TYPE_ARCHIVE_WRITER, filename, format, filters, error);
}


static Block12Data* block12_data_ref (Block12Data* _data12_) {
	g_atomic_int_inc (&_data12_->_ref_count_);
	return _data12_;
}


static void block12_data_unref (void * _userdata_) {
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
		BoxesArchiveWriter* self;
		self = _data12_->self;
		_g_free0 (_data12_->filename);
		_g_object_unref0 (self);
		g_slice_free (Block12Data, _data12_);
	}
}


static int __lambda67_ (Block12Data* _data12_) {
	BoxesArchiveWriter* self;
	int result = 0;
	struct archive* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	int _tmp2_ = 0;
	self = _data12_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data12_->filename;
	_tmp2_ = archive_write_open_filename (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static int ___lambda67__boxes_libarchive_function (gpointer self) {
	int result;
	result = __lambda67_ (self);
	return result;
}


BoxesArchiveWriter* boxes_archive_writer_construct_from_archive_reader (GType object_type, BoxesArchiveReader* archive_reader, const gchar* filename, gboolean import_contents, GError** error) {
	BoxesArchiveWriter * self = NULL;
	Block12Data* _data12_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	struct archive_entry* iterator = NULL;
	struct archive* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	BoxesArchiveReader* _tmp4_ = NULL;
	struct archive* _tmp5_ = NULL;
	struct archive_entry* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	BoxesArchiveReader* _tmp12_ = NULL;
	struct archive* _tmp13_ = NULL;
	int _tmp14_ = 0;
	BoxesArchiveReader* _tmp15_ = NULL;
	struct archive* _tmp16_ = NULL;
	struct archive* _tmp17_ = NULL;
	BoxesArchiveReader* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (archive_reader != NULL, NULL);
	g_return_val_if_fail (filename != NULL, NULL);
	_data12_ = g_slice_new0 (Block12Data);
	_data12_->_ref_count_ = 1;
	_tmp0_ = filename;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_data12_->filename);
	_data12_->filename = _tmp1_;
	self = (BoxesArchiveWriter*) g_object_new (object_type, NULL);
	_data12_->self = g_object_ref (self);
	_tmp2_ = archive_write_new ();
	_archive_write_finish0 (self->archive);
	self->archive = _tmp2_;
	_tmp4_ = archive_reader;
	_tmp5_ = _tmp4_->archive;
	_tmp7_ = boxes_get_next_header (_tmp5_, &_tmp6_, (guint) 1, &_inner_error_);
	iterator = _tmp6_;
	_tmp3_ = _tmp7_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block12_data_unref (_data12_);
			_data12_ = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			block12_data_unref (_data12_);
			_data12_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	if (!_tmp3_) {
		gchar* msg = NULL;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		_tmp8_ = g_strdup ("Error creating write archive for archive '%s'. It is probably empty.");
		msg = _tmp8_;
		_tmp9_ = msg;
		_tmp10_ = _data12_->filename;
		_tmp11_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp9_, _tmp10_);
		_inner_error_ = _tmp11_;
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (msg);
			block12_data_unref (_data12_);
			_data12_ = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			_g_free0 (msg);
			block12_data_unref (_data12_);
			_data12_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (msg);
	}
	_tmp12_ = archive_reader;
	_tmp13_ = _tmp12_->archive;
	_tmp14_ = archive_format (_tmp13_);
	self->priv->format = _tmp14_;
	_tmp15_ = archive_reader;
	_tmp16_ = _tmp15_->archive;
	boxes_archive_writer_copy_filters_from_read_archive (self, _tmp16_);
	boxes_archive_writer_prepare_archive (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block12_data_unref (_data12_);
			_data12_ = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			block12_data_unref (_data12_);
			_data12_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp17_ = self->archive;
	boxes_execute_libarchive_function (_tmp17_, ___lambda67__boxes_libarchive_function, _data12_, (guint) 1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block12_data_unref (_data12_);
			_data12_ = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			block12_data_unref (_data12_);
			_data12_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp18_ = archive_reader;
	boxes_archive_reader_reset (_tmp18_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block12_data_unref (_data12_);
			_data12_ = NULL;
			_g_object_unref0 (self);
			return NULL;
		} else {
			block12_data_unref (_data12_);
			_data12_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp19_ = import_contents;
	if (_tmp19_) {
		BoxesArchiveReader* _tmp20_ = NULL;
		_tmp20_ = archive_reader;
		boxes_archive_writer_import_read_archive (self, _tmp20_, NULL, 0, FALSE, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				block12_data_unref (_data12_);
				_data12_ = NULL;
				_g_object_unref0 (self);
				return NULL;
			} else {
				block12_data_unref (_data12_);
				_data12_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
	block12_data_unref (_data12_);
	_data12_ = NULL;
	return self;
}


BoxesArchiveWriter* boxes_archive_writer_new_from_archive_reader (BoxesArchiveReader* archive_reader, const gchar* filename, gboolean import_contents, GError** error) {
	return boxes_archive_writer_construct_from_archive_reader (BOXES_TYPE_ARCHIVE_WRITER, archive_reader, filename, import_contents, error);
}


static Block13Data* block13_data_ref (Block13Data* _data13_) {
	g_atomic_int_inc (&_data13_->_ref_count_);
	return _data13_;
}


static void block13_data_unref (void * _userdata_) {
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
		BoxesArchiveWriter* self;
		self = _data13_->self;
		_g_object_unref0 (self);
		g_slice_free (Block13Data, _data13_);
	}
}


static int ___lambda68_ (Block13Data* _data13_) {
	BoxesArchiveWriter* self;
	int result = 0;
	struct archive* _tmp0_ = NULL;
	struct archive_entry* _tmp1_ = NULL;
	int _tmp2_ = 0;
	self = _data13_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data13_->iterator;
	_tmp2_ = archive_write_header (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static int ____lambda68__boxes_libarchive_function (gpointer self) {
	int result;
	result = ___lambda68_ (self);
	return result;
}


void boxes_archive_writer_import_read_archive (BoxesArchiveWriter* self, BoxesArchiveReader* archive_reader, gchar** omit_files, int omit_files_length1, gboolean omit_hardlinked_files, GError** error) {
	Block13Data* _data13_;
	BoxesArchiveReader* _tmp32_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (archive_reader != NULL);
	_data13_ = g_slice_new0 (Block13Data);
	_data13_->_ref_count_ = 1;
	_data13_->self = g_object_ref (self);
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		BoxesArchiveReader* _tmp1_ = NULL;
		struct archive* _tmp2_ = NULL;
		struct archive_entry* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		gboolean omit = FALSE;
		gchar** _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		gboolean _tmp10_ = FALSE;
		gint64 len = 0LL;
		struct archive_entry* _tmp20_ = NULL;
		gint64 _tmp21_ = 0LL;
		struct archive* _tmp22_ = NULL;
		gint64 _tmp23_ = 0LL;
		_tmp1_ = archive_reader;
		_tmp2_ = _tmp1_->archive;
		_tmp4_ = boxes_get_next_header (_tmp2_, &_tmp3_, (guint) 1, &_inner_error_);
		_data13_->iterator = _tmp3_;
		_tmp0_ = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				block13_data_unref (_data13_);
				_data13_ = NULL;
				return;
			} else {
				block13_data_unref (_data13_);
				_data13_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		if (!_tmp0_) {
			break;
		}
		omit = FALSE;
		_tmp5_ = omit_files;
		_tmp5__length1 = omit_files_length1;
		{
			gchar** file_collection = NULL;
			gint file_collection_length1 = 0;
			gint _file_collection_size_ = 0;
			gint file_it = 0;
			file_collection = _tmp5_;
			file_collection_length1 = _tmp5__length1;
			for (file_it = 0; file_it < _tmp5__length1; file_it = file_it + 1) {
				gchar* _tmp6_ = NULL;
				gchar* file = NULL;
				_tmp6_ = g_strdup (file_collection[file_it]);
				file = _tmp6_;
				{
					const gchar* _tmp7_ = NULL;
					struct archive_entry* _tmp8_ = NULL;
					const gchar* _tmp9_ = NULL;
					_tmp7_ = file;
					_tmp8_ = _data13_->iterator;
					_tmp9_ = archive_entry_pathname (_tmp8_);
					if (g_strcmp0 (_tmp7_, _tmp9_) == 0) {
						omit = TRUE;
						_g_free0 (file);
						break;
					}
					_g_free0 (file);
				}
			}
		}
		_tmp10_ = omit;
		if (_tmp10_) {
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
			_tmp13_ = omit_hardlinked_files;
			if (_tmp13_) {
				_tmp12_ = TRUE;
			} else {
				struct archive_entry* _tmp14_ = NULL;
				guint _tmp15_ = 0U;
				_tmp14_ = _data13_->iterator;
				_tmp15_ = archive_entry_nlink (_tmp14_);
				_tmp12_ = _tmp15_ == ((guint) 1);
			}
			if (_tmp12_) {
				_tmp11_ = TRUE;
			} else {
				struct archive_entry* _tmp16_ = NULL;
				const gchar* _tmp17_ = NULL;
				_tmp16_ = _data13_->iterator;
				_tmp17_ = archive_entry_hardlink (_tmp16_);
				_tmp11_ = _tmp17_ != NULL;
			}
			if (_tmp11_) {
				continue;
			} else {
				struct archive_entry* _tmp18_ = NULL;
				const gchar* _tmp19_ = NULL;
				_tmp18_ = _data13_->iterator;
				_tmp19_ = archive_entry_pathname (_tmp18_);
				g_warning ("archive-writer.vala:68: File '%s' cannot be omitted since a hardlink p" \
"oints to it.", _tmp19_);
			}
		}
		_tmp20_ = _data13_->iterator;
		_tmp21_ = archive_entry_size (_tmp20_);
		len = _tmp21_;
		_tmp22_ = self->archive;
		boxes_execute_libarchive_function (_tmp22_, ____lambda68__boxes_libarchive_function, _data13_, (guint) 1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				block13_data_unref (_data13_);
				_data13_ = NULL;
				return;
			} else {
				block13_data_unref (_data13_);
				_data13_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		_tmp23_ = len;
		if (_tmp23_ > ((gint64) 0)) {
			guint8* buf = NULL;
			gint64 _tmp24_ = 0LL;
			guint8* _tmp25_ = NULL;
			gint buf_length1 = 0;
			gint _buf_size_ = 0;
			guint8* _tmp26_ = NULL;
			gint _tmp26__length1 = 0;
			BoxesArchiveReader* _tmp27_ = NULL;
			struct archive* _tmp28_ = NULL;
			guint8* _tmp29_ = NULL;
			gint _tmp29__length1 = 0;
			gint64 _tmp30_ = 0LL;
			gssize _tmp31_ = 0L;
			_tmp24_ = len;
			_tmp25_ = g_new0 (guint8, _tmp24_);
			buf = _tmp25_;
			buf_length1 = _tmp24_;
			_buf_size_ = buf_length1;
			_tmp26_ = buf;
			_tmp26__length1 = buf_length1;
			_tmp27_ = archive_reader;
			_tmp28_ = _tmp27_->archive;
			_tmp29_ = buf;
			_tmp29__length1 = buf_length1;
			_tmp30_ = len;
			_tmp31_ = archive_read_data (_tmp28_, _tmp29_, (gsize) _tmp30_);
			boxes_archive_writer_insert_data (self, _tmp26_, (gint64) _tmp31_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					g_propagate_error (error, _inner_error_);
					buf = (g_free (buf), NULL);
					block13_data_unref (_data13_);
					_data13_ = NULL;
					return;
				} else {
					buf = (g_free (buf), NULL);
					block13_data_unref (_data13_);
					_data13_ = NULL;
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			buf = (g_free (buf), NULL);
		}
	}
	_tmp32_ = archive_reader;
	boxes_archive_reader_reset (_tmp32_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block13_data_unref (_data13_);
			_data13_ = NULL;
			return;
		} else {
			block13_data_unref (_data13_);
			_data13_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	block13_data_unref (_data13_);
	_data13_ = NULL;
}


void boxes_archive_writer_insert_files (BoxesArchiveWriter* self, gchar** src_list, int src_list_length1, gchar** dest_list, int dest_list_length1, GError** error) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = src_list;
	_tmp0__length1 = src_list_length1;
	_tmp1_ = dest_list;
	_tmp1__length1 = dest_list_length1;
	g_return_if_fail (_tmp0__length1 == _tmp1__length1);
	{
		guint i = 0U;
		i = (guint) 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				guint _tmp4_ = 0U;
				gchar** _tmp5_ = NULL;
				gint _tmp5__length1 = 0;
				gchar** _tmp6_ = NULL;
				gint _tmp6__length1 = 0;
				guint _tmp7_ = 0U;
				const gchar* _tmp8_ = NULL;
				gchar** _tmp9_ = NULL;
				gint _tmp9__length1 = 0;
				guint _tmp10_ = 0U;
				const gchar* _tmp11_ = NULL;
				if (!_tmp2_) {
					guint _tmp3_ = 0U;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = i;
				_tmp5_ = src_list;
				_tmp5__length1 = src_list_length1;
				if (!(_tmp4_ < ((guint) _tmp5__length1))) {
					break;
				}
				_tmp6_ = src_list;
				_tmp6__length1 = src_list_length1;
				_tmp7_ = i;
				_tmp8_ = _tmp6_[_tmp7_];
				_tmp9_ = dest_list;
				_tmp9__length1 = dest_list_length1;
				_tmp10_ = i;
				_tmp11_ = _tmp9_[_tmp10_];
				boxes_archive_writer_insert_file (self, _tmp8_, _tmp11_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == G_IO_ERROR) {
						g_propagate_error (error, _inner_error_);
						return;
					} else {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
			}
		}
	}
}


static Block14Data* block14_data_ref (Block14Data* _data14_) {
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}


static void block14_data_unref (void * _userdata_) {
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		BoxesArchiveWriter* self;
		self = _data14_->self;
		_archive_entry_free0 (_data14_->entry);
		_g_object_unref0 (self);
		g_slice_free (Block14Data, _data14_);
	}
}


static int __lambda69_ (Block14Data* _data14_) {
	BoxesArchiveWriter* self;
	int result = 0;
	struct archive* _tmp0_ = NULL;
	struct archive_entry* _tmp1_ = NULL;
	int _tmp2_ = 0;
	self = _data14_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data14_->entry;
	_tmp2_ = archive_write_header (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static int ___lambda69__boxes_libarchive_function (gpointer self) {
	int result;
	result = __lambda69_ (self);
	return result;
}


void boxes_archive_writer_insert_file (BoxesArchiveWriter* self, const gchar* src, const gchar* dest, GError** error) {
	Block14Data* _data14_;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	struct archive_entry* _tmp9_ = NULL;
	gint64 len = 0LL;
	struct archive_entry* _tmp10_ = NULL;
	gint64 _tmp11_ = 0LL;
	guint8* buf = NULL;
	gint64 _tmp12_ = 0LL;
	guint8* _tmp13_ = NULL;
	gint buf_length1 = 0;
	gint _buf_size_ = 0;
	FILE* filestream = NULL;
	const gchar* _tmp14_ = NULL;
	FILE* _tmp15_ = NULL;
	FILE* _tmp16_ = NULL;
	guint8* _tmp17_ = NULL;
	gint _tmp17__length1 = 0;
	gint64 _tmp18_ = 0LL;
	struct archive* _tmp19_ = NULL;
	guint8* _tmp20_ = NULL;
	gint _tmp20__length1 = 0;
	gint64 _tmp21_ = 0LL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (src != NULL);
	g_return_if_fail (dest != NULL);
	_data14_ = g_slice_new0 (Block14Data);
	_data14_->_ref_count_ = 1;
	_data14_->self = g_object_ref (self);
	_tmp0_ = src;
	_tmp1_ = g_file_test (_tmp0_, G_FILE_TEST_EXISTS);
	if (!_tmp1_) {
		const gchar* _tmp2_ = NULL;
		GError* _tmp3_ = NULL;
		_tmp2_ = src;
		_tmp3_ = g_error_new (G_IO_ERROR, G_IO_ERROR_NOT_FOUND, "Source file '%s' cannot be injected. File not found.", _tmp2_);
		_inner_error_ = _tmp3_;
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block14_data_unref (_data14_);
			_data14_ = NULL;
			return;
		} else {
			block14_data_unref (_data14_);
			_data14_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp4_ = src;
	_tmp5_ = g_file_test (_tmp4_, G_FILE_TEST_IS_SYMLINK);
	if (_tmp5_) {
		GError* _tmp6_ = NULL;
		_tmp6_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "Inserting symlinks is currently not supported.");
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			block14_data_unref (_data14_);
			_data14_ = NULL;
			return;
		} else {
			block14_data_unref (_data14_);
			_data14_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp7_ = src;
	_tmp8_ = dest;
	_tmp9_ = boxes_archive_writer_get_entry_for_file (self, _tmp7_, _tmp8_);
	_data14_->entry = _tmp9_;
	_tmp10_ = _data14_->entry;
	_tmp11_ = archive_entry_size (_tmp10_);
	len = _tmp11_;
	_tmp12_ = len;
	_tmp13_ = g_new0 (guint8, _tmp12_);
	buf = _tmp13_;
	buf_length1 = _tmp12_;
	_buf_size_ = buf_length1;
	_tmp14_ = src;
	_tmp15_ = g_fopen (_tmp14_, "r");
	filestream = _tmp15_;
	_tmp16_ = filestream;
	_tmp17_ = buf;
	_tmp17__length1 = buf_length1;
	_tmp18_ = len;
	fread ((guint8*) _tmp17_, (gsize) _tmp18_, (_tmp17__length1 * sizeof (guint8)) / sizeof (guint8), _tmp16_);
	_tmp19_ = self->archive;
	boxes_execute_libarchive_function (_tmp19_, ___lambda69__boxes_libarchive_function, _data14_, (guint) 1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_fclose0 (filestream);
			buf = (g_free (buf), NULL);
			block14_data_unref (_data14_);
			_data14_ = NULL;
			return;
		} else {
			_fclose0 (filestream);
			buf = (g_free (buf), NULL);
			block14_data_unref (_data14_);
			_data14_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp20_ = buf;
	_tmp20__length1 = buf_length1;
	_tmp21_ = len;
	boxes_archive_writer_insert_data (self, (guint8*) _tmp20_, _tmp21_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_fclose0 (filestream);
			buf = (g_free (buf), NULL);
			block14_data_unref (_data14_);
			_data14_ = NULL;
			return;
		} else {
			_fclose0 (filestream);
			buf = (g_free (buf), NULL);
			block14_data_unref (_data14_);
			_data14_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_fclose0 (filestream);
	buf = (g_free (buf), NULL);
	block14_data_unref (_data14_);
	_data14_ = NULL;
}


static int __lambda64_ (BoxesArchiveWriter* self) {
	int result = 0;
	struct archive* _tmp0_ = NULL;
	int _tmp1_ = 0;
	int _tmp2_ = 0;
	_tmp0_ = self->archive;
	_tmp1_ = self->priv->format;
	_tmp2_ = archive_write_set_format (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static int ___lambda64__boxes_libarchive_function (gpointer self) {
	int result;
	result = __lambda64_ ((BoxesArchiveWriter*) self);
	return result;
}


static Block15Data* block15_data_ref (Block15Data* _data15_) {
	g_atomic_int_inc (&_data15_->_ref_count_);
	return _data15_;
}


static void block15_data_unref (void * _userdata_) {
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
		BoxesArchiveWriter* self;
		self = _data15_->self;
		_g_object_unref0 (self);
		g_slice_free (Block15Data, _data15_);
	}
}


static int _____lambda65_ (Block15Data* _data15_) {
	BoxesArchiveWriter* self;
	int result = 0;
	struct archive* _tmp0_ = NULL;
	int _tmp1_ = 0;
	int _tmp2_ = 0;
	self = _data15_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data15_->filter;
	_tmp2_ = archive_write_add_filter (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static int ______lambda65__boxes_libarchive_function (gpointer self) {
	int result;
	result = _____lambda65_ (self);
	return result;
}


static void boxes_archive_writer_prepare_archive (BoxesArchiveWriter* self, GError** error) {
	struct archive* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->archive;
	boxes_execute_libarchive_function (_tmp0_, ___lambda64__boxes_libarchive_function, self, (guint) 1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp1_ = self->priv->filters;
	if (_tmp1_ != NULL) {
		GList* _tmp2_ = NULL;
		_tmp2_ = self->priv->filters;
		{
			GList* filter_collection = NULL;
			GList* filter_it = NULL;
			filter_collection = _tmp2_;
			for (filter_it = filter_collection; filter_it != NULL; filter_it = filter_it->next) {
				int filter = 0;
				filter = (int) ((gintptr) filter_it->data);
				{
					Block15Data* _data15_;
					struct archive* _tmp3_ = NULL;
					_data15_ = g_slice_new0 (Block15Data);
					_data15_->_ref_count_ = 1;
					_data15_->self = g_object_ref (self);
					_data15_->filter = filter;
					_tmp3_ = self->archive;
					boxes_execute_libarchive_function (_tmp3_, ______lambda65__boxes_libarchive_function, _data15_, (guint) 1, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == G_IO_ERROR) {
							g_propagate_error (error, _inner_error_);
							block15_data_unref (_data15_);
							_data15_ = NULL;
							return;
						} else {
							block15_data_unref (_data15_);
							_data15_ = NULL;
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					block15_data_unref (_data15_);
					_data15_ = NULL;
				}
			}
		}
	}
}


static void boxes_archive_writer_copy_filters_from_read_archive (BoxesArchiveWriter* self, struct archive* read_archive) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (read_archive != NULL);
	_g_list_free0 (self->priv->filters);
	self->priv->filters = NULL;
	{
		gint i = 0;
		struct archive* _tmp0_ = NULL;
		gint _tmp1_ = 0;
		_tmp0_ = read_archive;
		_tmp1_ = archive_filter_count (_tmp0_);
		i = _tmp1_ - 1;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_ = 0;
				struct archive* _tmp5_ = NULL;
				gint _tmp6_ = 0;
				int _tmp7_ = 0;
				if (!_tmp2_) {
					gint _tmp3_ = 0;
					_tmp3_ = i;
					i = _tmp3_ - 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = i;
				if (!(_tmp4_ > 0)) {
					break;
				}
				_tmp5_ = read_archive;
				_tmp6_ = i;
				_tmp7_ = archive_filter_code (_tmp5_, _tmp6_ - 1);
				self->priv->filters = g_list_append (self->priv->filters, (gpointer) ((gintptr) _tmp7_));
			}
		}
	}
}


static void boxes_archive_writer_insert_data (BoxesArchiveWriter* self, void* data, gint64 len, GError** error) {
	struct archive* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	gint64 _tmp2_ = 0LL;
	gssize _tmp3_ = 0L;
	gint64 _tmp4_ = 0LL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->archive;
	_tmp1_ = data;
	_tmp2_ = len;
	_tmp3_ = archive_write_data (_tmp0_, _tmp1_, (gsize) _tmp2_);
	_tmp4_ = len;
	if (((gint64) _tmp3_) != _tmp4_) {
		struct archive* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		_tmp5_ = self->archive;
		_tmp6_ = archive_error_string (_tmp5_);
		_tmp7_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "Failed writing data to archive. Message: '%s'.", _tmp6_);
		_inner_error_ = _tmp7_;
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static struct archive_entry* boxes_archive_writer_get_entry_for_file (BoxesArchiveWriter* self, const gchar* filename, const gchar* dest_name) {
	struct archive_entry* result = NULL;
	struct stat st = {0};
	struct archive_entry* _result_ = NULL;
	struct archive_entry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	struct stat _tmp2_ = {0};
	struct stat _tmp3_ = {0};
	const gchar* _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (filename != NULL, NULL);
	g_return_val_if_fail (dest_name != NULL, NULL);
	_tmp0_ = archive_entry_new ();
	_result_ = _tmp0_;
	_tmp1_ = filename;
	stat (_tmp1_, &_tmp2_);
	st = _tmp2_;
	_tmp3_ = st;
	archive_entry_copy_stat (_result_, &_tmp3_);
	_tmp4_ = dest_name;
	archive_entry_set_pathname (_result_, _tmp4_);
	result = _result_;
	return result;
}


static void boxes_archive_writer_class_init (BoxesArchiveWriterClass * klass) {
	boxes_archive_writer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BoxesArchiveWriterPrivate));
	G_OBJECT_CLASS (klass)->finalize = boxes_archive_writer_finalize;
}


static void boxes_archive_writer_instance_init (BoxesArchiveWriter * self) {
	self->priv = BOXES_ARCHIVE_WRITER_GET_PRIVATE (self);
}


static void boxes_archive_writer_finalize (GObject* obj) {
	BoxesArchiveWriter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_ARCHIVE_WRITER, BoxesArchiveWriter);
	_archive_write_finish0 (self->archive);
	_g_list_free0 (self->priv->filters);
	G_OBJECT_CLASS (boxes_archive_writer_parent_class)->finalize (obj);
}


GType boxes_archive_writer_get_type (void) {
	static volatile gsize boxes_archive_writer_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_archive_writer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesArchiveWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_archive_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesArchiveWriter), 0, (GInstanceInitFunc) boxes_archive_writer_instance_init, NULL };
		GType boxes_archive_writer_type_id;
		boxes_archive_writer_type_id = g_type_register_static (G_TYPE_OBJECT, "BoxesArchiveWriter", &g_define_type_info, 0);
		g_once_init_leave (&boxes_archive_writer_type_id__volatile, boxes_archive_writer_type_id);
	}
	return boxes_archive_writer_type_id__volatile;
}



